{
  a Z-80 assembly language compiler for ZX-SPECTRUM (48/128/512/1024)

  DESCRIPT: labels handler.

                                 was written by SCREW/OHG/CM
                                   all rights reserved
}
Unit C_Z80Labels;

INTERFACE

Const max_Labels=3400;
      max_Lab_len=16;
Type Metka=Record
            name:string[max_Lab_len];
            value:word
           end;
     lab_table=Record
                labs:array[1..max_Labels] of Metka;
                last_found:integer;
                last_global:string[max_Lab_len];
                total:integer
               end;
      lab_Ptr=^lab_table;

Var lab:lab_Ptr;

Procedure Table_Init(var T:lab_Ptr);
Procedure Table_Reinit(var T:lab_Ptr);
Procedure Table_Deinit(var T:lab_Ptr);
Procedure Table_Reset(var T:lab_Ptr);
Function isExist(T:lab_Ptr; name:string;var value:word):boolean;
Procedure Table_Add(var T:lab_Ptr; name:string; value:word);
Function get_Label(T:lab_Ptr; name:string; var value:word):boolean;
Procedure set_Label(var T:lab_Ptr; var name:string; value:word);

IMPLEMENTATION

Uses C_ErrHandle, { using error handler }
     C_Z80Macros, { using 'is_next_add' }
     C_Z80Codes;  { using 'GetWord' }
{$I C_Z80ERR.pas} {include errors definition }

{***************************************************************************
                      ALL CODE IMPLEMENTATIONS
***************************************************************************}

Procedure Table_Init(var T:lab_Ptr);
Begin
 new(T);
 T^.last_found:=0;
 T^.last_global:='';
 T^.total:=0
end;

Procedure Table_Reinit(var T:lab_Ptr);
Begin
 T^.last_found:=0;
 T^.last_global:=''
end;

Procedure Table_Deinit(var T:lab_Ptr);
Begin
 dispose(T)
end;

Procedure Table_Reset(var T:lab_Ptr);
Begin
{ T^.total:=0}
end;

Function isExist(T:lab_Ptr; name:string;var value:word):boolean;
Var i:integer;
Begin
 isExist:=false;
 for i:=1 to T^.total do
  if T^.labs[i].name=name then Begin
                                isExist:=true;
                                value:=T^.labs[i].value;
                                T^.last_found:=i;
                                break
                               end
end;

Function get_Label(T:lab_Ptr; name:string; var value:word):boolean;
Var i:integer;
    si:integer;
Begin
 si:=1;
 if name[1]='@' then { go to last global label }
  if isExist(T, T^.last_global, value ) then si:=T^.last_found+1;
 get_Label:=false;
 for i:=si to T^.total do
  Begin
   if (name[1]='@') and (T^.labs[i].name[1]<>'@') then break;
   if T^.labs[i].name=name then Begin
                                 get_Label:=true;
                                 value:=T^.labs[i].value;
                                 break
                                end
  end
end;


Procedure Table_Add(var T:lab_Ptr; name:string; value:word);
var num:integer;
      v:word;
      i:integer;
    err:boolean;
Begin
 err:=false;
 if isExist(T,name,v) then
  Begin
   err:=true;
  { label exists } if name[1]='@' then
   Begin
    { check for hide by global }
     if isExist(T, T^.last_global, v ) then i:=T^.last_found
                                       else i:=1;
     err:=false;
     for i:=i to T^.total do
     if T^.labs[i].name=name then Begin
                                   err:=true; {labels is not hided}
                                   break
                                  end
   end
  end;

 if err then Error(LABEL_ALREADY_EXISTS)
else
 if T^.total>=max_labels then Error(TOO_MANY_LABELS)
else
 Begin
  inc(T^.total);
  T^.labs[T^.total].name:=name;
  T^.labs[T^.total].value:=value
 end
end;

Procedure set_Label(var T:lab_Ptr;var name:string; value:word);
var i,len:integer;
    s1:string;
Begin
 i:=1;
 s1:=GetWord(name,i);
 len:=length(s1);
 { LABELS }
 if not is_next_add and
    (s1[len]=':') then Begin
{                        write(s1);
 }                       s1:=copy(s1,1,length(s1)-1); {delete : }
                        if pass=1 then {set only on first pass}
                                       Table_Add(T, s1, org);
                        { update global flag}
                        if s1[1]<>'@' then T^.last_global:=s1;
                        { remove label }
                         name:=Replace(name,s1+':','');
                       end;
end;


end.