{
  a Z-80 assembly language compiler for ZX-SPECTRUM (48/128/512/1024)

  DESCRIPT: EQU's, ='s & defines handler.

                                 was written by SCREW/OHG/CM
                                   all rights reserved
}
Unit C_Z80Ram;

INTERFACE


Procedure RAM_Init;
Procedure RAM_Deinit;
Procedure RAM_Put(dest:word);
Procedure RAM_Store(name:string; start,len:word);
Procedure RAM_Insert(name:string; var dest:word);

IMPLEMENTATION
Uses C_Z80Codes;  { using 'bytes' }

Type page=array[0..16383] of byte;
     page_Ptr=^page;

Var pg1,pg2:page_Ptr;

{***************************************************************************
                      ALL CODE IMPLEMENTATIONS
***************************************************************************}

Procedure RAM_Init;
Begin
 new(pg1);
 new(pg2);
end;

Procedure RAM_Deinit;
Begin
 dispose(pg1);
 dispose(pg2)
end;

Procedure Ram_Put(dest:word);
Var ram:page_Ptr;
    i:integer;
    addr:word;
Begin
 with bytes do
  for i:=1 to code_len do
   Begin
    if dest<32768 then Begin
                        ram:=pg1;
                        addr:=dest
                       end else Begin
                                 ram:=pg2;
                                 addr:=dest-32768
                                end;
    ram^[addr]:=code_set[i];
    inc(dest)
   end
end;

Procedure RAM_Store(name:string; start,len:word);
var f:file;
    ram:page_Ptr;
    bl_len,addr:word;
    err:integer;
{!}{    tr_name:array[1..17] of byte; i:integer; s:byte;}
Begin
 if name='' then exit;
 assign(f,name);
 rewrite(f,1);
{create HOBETA file}
{ tr_name[9]:=ord('C');
 for i:=1 to 8 do tr_name[i]:=ord(name[i]);
 tr_name[10]:=lo(start); tr_name[11]:=hi(start);
 tr_name[12]:=lo(len); tr_name[13]:=hi(len);
 s:=0; for i:=1 to 15 do s:=s+tr_name[i];
 tr_name[16]:=s+105; tr_name[17]:=s+3;
 BlockWrite(f,tr_name,17,err);        }

 while(len>0) do
  Begin
   if start<32768 then Begin
                        ram:=pg1;
                        addr:=start;
                        end else Begin
                                  ram:=pg2;
                                  addr:=start-32768
                                 end;
   bl_len:=len;
   if bl_len+addr>32768 then bl_len:=32768-addr;
   Blockwrite(f,ram^[addr],bl_len,err);
   len:=len-bl_len;
   start:=start+bl_len
  end;
 close(f)
end;

Procedure RAM_Insert(name:string; var dest:word);
var f:file;
    ram:page_Ptr;
    bl_len,addr,len:word;
    err:integer;
Begin
 if name='' then exit;
 assign(f,name);
 reset(f,1);
 len:=FileSize(f);
 while(len>0) do
  Begin
   if dest<32768 then Begin
                        ram:=pg1;
                        addr:=dest;
                        end else Begin
                                  ram:=pg2;
                                  addr:=dest-32768
                                 end;
   bl_len:=len;
   if bl_len+addr>32768 then bl_len:=32768-addr;
   BlockRead(f,ram^[addr],bl_len,err);
   len:=len-bl_len;
   dest:=dest+bl_len
  end;
 close(f)
end;

end.